#/usr/bin/env python
#-*- encoding:utf-8 -*-

# Aufrufen durch das Laden über das Scribus-Menu.

# (c) Jonas Bechtel 2017

import scribus
import re
doc_name = scribus.getDocName();
path_name = re.sub(r'[^/]+$', '', doc_name);
#import os
#os.chdir(path_name);

try:
	unused_var = first_run_only;
except NameError:
	first_run_only = 0;



user_layer = scribus.getActiveLayer();

f = open(path_name + 'Switch_Text.py'); exec(f.read()); f.close();

# Synonymregister erzeugen, bevor WiScri läuft.
f = open(path_name + 'Scribus-SynReg.py'); exec(f.read()); f.close();

# TODO: Ablauf modifizieren:
# 1. SynReg
# 2. First Run
# 3. TOC-Run
# 4. 


#f = open(path_name + 'helper/copystring.py'); exec(f.read()); f.close();


print('main beep');

variant = VARIANT_FULL;
variant = VARIANT_NOREACH;
docvars = switch_text(variant, []);

# variant = re.sub(r'^ *', '', scribus.getText("Kopie von Tmagic_Praegung____f0"));


if (first_run_only == 0):
	
	pagerange = final_PDF(variant, path_name + 'tmp_markpos.pdf');
	
	pagemarks = [0];
	buf = prepare_marks(pagemarks, path_name + 'tmp_markpos.pdf');
	print (pagemarks);
	
# Ganz viele TODO hier!!
#scribus.openDoc(path_name + 'tmp_markpos.sla')

	# TODO: Hauptablauf insgesamt sollte sein:
	#	1. Tmagic auf alle Inhalte laufen lassen
	#	1.a Das TOC kommt ganz am Ende
	#	2. Vor-pdf-Export (Mark-Positionen rausfinden)
	#	3. Tmagic (nur) auf alle Tmagic-Rahmen laufen lassen, bei denen die Seitennummern ausgetauscht werden müssen. (oder nur die einzelnen Seitennummern selbst tauschen? - nein, da verlieren wir Flexibilität.)
	#	4. Dokument schließen
	#	5. pdf-Annotationen an der Originaldatei vornehmen
	#	6. Dokument wieder öffnen
	#	7. Haupt-pdf-Export.
	# [Bei den pdf-Exports wird das Inhaltsverzeichnis nach vorne genommen.]
	
	# TODO: In Ref_db: 1. Seitenzahlen, die aktualisiert werden müssen.
	#                  2. Links, die geklickt werden sollen. (Hier Herkunft und Ziel relevant.)
	#  d. h. ref_db -> ref_vars
	# folgendes funktioniert schon:
	find_mark(buf, pagemarks, b'1', -1, [])
	find_mark(buf, pagemarks, b'Wort', 3, b'Wort')
	#-> [[22, '165.846930', '281.371440', '181.878930', '294.331440']]
	#   [[22, '146.566930', '323.371440', '181.846930', '336.331440'], [22, '254.170930', '323.371440', '289.450930', '336.331440']]
	
	find_mark_simple(buf, pagemarks, b'CH 2');
	
	mark_cnt = int(get_var(docvars, '__mark_cnt'));
	i = 0;
	extravars = [['_____', '-----']];
	while i < mark_cnt:
		i += 1;
		varname = '__mark_' + str(i);
		mark_name = get_var(docvars, varname);
		print (['Mark: ', mark_name])
		page_etc = find_mark_simple(buf, pagemarks, mark_name);
		set_var(extravars, varname + '_page', page_etc[0]);
	
	toc_cnt = int(get_var(docvars, '__toc_cnt_toc'));
	i = 0;
	while i < toc_cnt:
		i += 1;
		varname = '__toc_mark_' + str(i) + '_toc';
		mark_name = get_var(docvars, varname);
		print (['Mark (TOC): ', mark_name])
		page_etc = find_mark_simple(buf, pagemarks, mark_name.encode('utf-8'));
		if page_etc[0][0] == -1:
			print ('Main.py: for TOC wasn"t following mark found: {}'.format(mark_name));
		else:
			set_var(extravars, '__toc_page_' + str(i) + '_toc', pagerange[page_etc[0][0]-1]);
	
	i = 0;
	while i < len(docvars):
		if len(docvars[i]) > 2:
			if docvars[i][2] == DOCVAR_PERSISTENT:
				set_var(extravars, docvars[i][0], docvars[i][1]);
				set_persistent(extravars, docvars[i][0], DOCVAR_PERSISTENT);
		
		i += 1;
	
	dump_vars(extravars);
	
	
	
	# [I guess this could be done before exporting the pdf? So maybe there's only one export?]
	#  [No, there are two exports as we need an annotation step.]
	# saveDoc()
	# closeDoc()
	# TODO: pdf annotate: Klickbare Inner-Dokumentenlinks.
	# openDoc(tmp.sla)
#	scribus.saveDoc()
#	scribus.saveDocAs(path_name + 'tmp_markpos.sla');
#	scribus.closeDoc()
	
	# Wenn das zweite/Vierte Feld zwischen dem ersten und dem letzten Wort
	# wechseln, einfach alles bis zum Seitenrand annotieren.
	# Achtung: Die Marker könnten auf verschiedenen Seiten liegen!
	
	
	# The second run is there ONLY for writing the page numbers into
	#  the respective Tmagic references!
	set_var(extravars, 'SECOND_RUN', '1');
	extravars
	# Das wird alleine für die Seitenzahlangabe gebraucht:
	switch_text(variant, extravars);
	
	# TODO: Omit second page for VARIANT_FULL ?
	print ('Exporting variant=>>{}<<'.format(variant));
	final_PDF(variant, []);
#

scribus.setActiveLayer(user_layer);



