#/usr/bin/env python
#-*- encoding:utf-8 -*-

# Übernommen vom Projekt Gegengleis (SkS) v0.798c



# Aufrufen mit: execfile('Scribus-SynReg.py') oder direkt aus Scribus;

# (c) Jonas Bechtel 2017



# Das Synonymregister importieren...



import scribus

import re
path_name = re.sub(r'[^/]+$', '', scribus.getDocName()); # copied from Switch_Text.py
# TODO: Is there a possibility to make this globally?

# Only for ALLOWED_FIELDS:
f = open(path_name + 'Switch_Text.py'); exec(f.read()); f.close();

file_synreg = path_name + 'extra/Synonymregister.txt'


style_orig_normal='Fliesstext';

#import os
#print os.path.abspath('.');

_fp = open(file_synreg, 'r');
src = _fp.read();


sr_name = 'SynReg';
sr_name = 'Tmagic_SynReg____f0'
scribus.setText('', sr_name)

longlist = [[0, 0]];


start = 0;
dobreak = 0;
while dobreak == 0:
	foundnl = src.find('\n', start);
	if (foundnl == -1):
		dobreak = 1;
	#print foundnl;
	
	if dobreak:
		line = src[start:];
	else:
		line = src[start:foundnl+1];
	#print '{}XXX'.format(line);
	
	maybecomment = 1;
	
	if (len(line) > 9):
		if (line[0:8] == '##STYLE:'):
			style_orig_normal = line[8:foundnl-start];
	
	if (len(line) > 9):
		if (line[0:8] == '##EMPHA:'):
			font_emphasized = line[8:foundnl-start];
	
	if len(line) > 3:
		try:
			l = ALLOWED_FIELDS.__iter__();
			while True:
				ftext = l.__next__();
				if (line.find('##'+ftext) == 0):
					maybecomment = 0;
					break;
		except StopIteration:
			l = '';
	
	if maybecomment and len(line) > 1:
		if line[0] == '#':
			start = foundnl + 1
			continue;
	
	secstart = 0;
	done = 0;
	use_style = 1; # 0: normal, 1: emphasized.
	#style = 'Fliesstext-Aufzaehlung: Fetter Begriff';
	style = ''
	while done == 0:
		foundstar = line.find('**', secstart);
		if (foundstar == -1):
			foundstar = len(line);
			done = 1;
		
		use_style = 1 - use_style;
		
		scribus.setStyle(style_orig_normal, sr_name);
		if (done == 1):
			scribus.insertText(line[secstart:], -1, sr_name);
		else:
			scribus.insertText(line[secstart:foundstar], -1, sr_name);
		if (use_style == 1):
			tl = scribus.getTextLength(sr_name);
			sel1 = tl - (foundstar-secstart);
			sel2 = (foundstar-secstart);
	#		print 'tl={}, secstart={}, foundstar={}    ->  {}:{}'.format(tl, secstart, foundstar, sel1, sel2);
			longlist.append([sel1, sel2]);
		#	scribus.selectText(sel1, sel2, sr_name);
			#scribus.selectText(240, 4, sr_name);
		#	scribus.setFont('VenturisSans ADF Bold', sr_name);
		
		secstart = foundstar + 2;
		
	
	#scribus.insertText(line, -1, sr_name);
	start = foundnl + 1

# print longlist;

for ll in range(1, len(longlist)):
	scribus.selectText(longlist[ll][0], longlist[ll][1], sr_name);
	scribus.setFont(font_emphasized, sr_name);


print ('Scribus-Inhalt.py: Synonymregister erzeugt!');

